#ifndef XPLODEDOC_H
#define XPLODEDOC_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// Include files for QT
#include <qobject.h>
#include <qstring.h>
#include <qdir.h>
#include <qfileinfo.h>
//#include <qwidget.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
//#include <qlist.h>
#include <qtextstream.h>

// Include file for Xplode
#include "xplodeeditor.h"
// forward declaration of the Xplode classes
// class XplodeView;

// Derived from QObject, provides document handling
class XplodeDoc : public QObject
{
	Q_OBJECT

public:
	XplodeDoc();
	~XplodeDoc();

	void connectEditor(XplodeEditor *editor);
	bool canCloseDocument();
	bool isModified() { return modified; };
	void deleteContents();
	bool newDocument();
	bool openDocument(QString filename);
	bool saveDocument(QString filename);
	void setPathName(QString name);
	QString pathName();
	void setTitle(QString title);
	QString title();
	XplodeEditor* getEditor() { return docEditor; };

signals:
	void documentModified(XplodeDoc*);
	void documentSaved(XplodeDoc*);
	void documentCursor(QString);

private:
	// Is modidied
	bool modified;
	// Document title and complete path
	QString docTitle;
	QString docFileName;

	// The document editor
	XplodeEditor *docEditor;

public slots:
	void setModified(bool m = true);
	void cursorPosition(int para, int idx);
};

#endif
